//
#include "globals.hh"

#include <fstream>

class HitStatus
{
public:
  static HitStatus* GetHitStatus();

public:
  void InitAtBeginOfRunAction();
  void InitAtBeginOfEventAction();

  void IncrementNumber(){++m_number;}
  G4int GetNumber(){return m_number;}
  void SetStatus(bool status){m_status = status;}
  G4bool GetStatus(){return m_status;}
  void SetEnergy(G4double energy){m_energy = energy;}
  G4double GetEnergy(){return m_energy;}
  void SetErel(G4double erel){m_erel = erel;}
  G4double GetErel(){return m_erel;}

public:
  std::ofstream ofs;
  
private:
  HitStatus();
  ~HitStatus();

  G4bool m_status;
  G4int m_number;
  G4double m_energy;
  G4double m_erel;

  static HitStatus* hitStatus;
};

