//
#include "BeamMessenger.hh"

#include "PrimaryGeneratorAction.hh"

#include "G4UIdirectory.hh"
#include "G4UIcmdWithADoubleAndUnit.hh"

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......

BeamMessenger::BeamMessenger(PrimaryGeneratorAction* Pri):Primary(Pri)
{
  gunDir = new G4UIdirectory("/gun/");
  gunDir->SetGuidance("Modification Commands for Hime");

  erelCmd = new G4UIcmdWithADoubleAndUnit("/gun/erel",this);
  erelCmd->SetGuidance("Set Relative Energy");
  erelCmd->SetParameterName("relative_energy",false);
  erelCmd->SetUnitCategory("Energy");
  erelCmd->SetRange("relative_energy>=0");
  erelCmd->AvailableForStates(G4State_PreInit,G4State_Idle);
}

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......

BeamMessenger::~BeamMessenger()
{
  delete gunDir;
  delete erelCmd;
}

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......

void BeamMessenger::SetNewValue(G4UIcommand* command, G4String newValue)
{
  if( command == erelCmd ){
    Primary->SetErel(erelCmd->GetNewDoubleValue(newValue));
  }
}

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......

