//
#include "DetectorConstruction.hh"
#include "G4HCofThisEvent.hh"
#include "G4SDManager.hh"
#include "G4VPhysicalVolume.hh"
#include "G4Step.hh"
#include "G4Track.hh"
#include "G4VTouchable.hh"
#include "G4TouchableHistory.hh"
#include "G4VProcess.hh"

#include "HimeSD.hh"
#include "HitStatus.hh"

HimeSD::HimeSD(G4String name)
  : G4VSensitiveDetector(name)
{;}

HimeSD::~HimeSD()
{;}

void HimeSD::Initialize(G4HCofThisEvent* /* HCE */)
{;}

void HimeSD::EndOfEvent(G4HCofThisEvent*)
{;}

G4bool HimeSD::ProcessHits(G4Step* aStep, G4TouchableHistory* /*ROhist*/)
{
  G4StepPoint* preStepPoint = aStep->GetPreStepPoint();

  HitStatus* hitStatus = HitStatus::GetHitStatus();
  if(preStepPoint->GetStepStatus() == fGeomBoundary and hitStatus->GetStatus() == false){
//    G4double x = preStepPoint->GetPosition().x();
//    G4double y = preStepPoint->GetPosition().y();
//    G4double z = preStepPoint->GetPosition().z();
//    std::cout << x/cm << " " << y/cm << " " << z/cm << std::endl;

    hitStatus->SetStatus(true);
  }
  
  return true;
}
